from django.contrib import admin

from toolshed.models import InventoryItem, Property, Tag, Category


class InventoryItemAdmin(admin.ModelAdmin):
    list_display = ('name', 'description', 'category', 'availability_policy', 'owned_quantity', 'owner')
    search_fields = ('name', 'description', 'category', 'availability_policy', 'owned_quantity', 'owner')


admin.site.register(InventoryItem, InventoryItemAdmin)


class PropertyAdmin(admin.ModelAdmin):
    list_display = ('name', 'description', 'category', 'unit_symbol', 'base2_prefix', 'dimensions', 'origin')
    search_fields = ('name', 'description', 'category', 'unit_symbol', 'base2_prefix', 'dimensions', 'origin')


admin.site.register(Property, PropertyAdmin)


class TagAdmin(admin.ModelAdmin):
    list_display = ('name', 'description', 'category', 'origin')
    search_fields = ('name', 'description', 'category', 'origin')


admin.site.register(Tag, TagAdmin)


class CategoryAdmin(admin.ModelAdmin):
    list_display = ('name', 'description', 'parent', 'origin')
    search_fields = ('name', 'description', 'parent', 'origin')


admin.site.register(Category, CategoryAdmin)
